=== requirements.txt ===
# The documentation uses 'mkdocs', which is written in Python
mkdocs-material
mkdocs-minify-plugin
