=== debian/changelog ===
ntfy (2.11.0-2) unstable; urgency=medium

  * Team upload.

  [ Otto Kekäläinen ]
  * Update gitlab-ci.yml to match the latest one in @go-team/infra/pkg-go-tools

 -- Simon Josefsson <simon@josefsson.org>  Tue, 18 Feb 2025 20:58:19 +0100

ntfy (2.11.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1078571)

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Fri, 17 Jan 2025 20:40:24 +0000
