=== debian/control ===
Source: ntfy
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Ahmad Khalifa <ahmad@khalifa.ws>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 1.19.8),
               golang-github-emersion-go-sasl-dev,
               golang-github-emersion-go-smtp-dev,
               golang-github-gabriel-vasile-mimetype-dev,
               golang-github-gorilla-websocket-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-microcosm-cc-bluemonday-dev,
               golang-github-olebedev-when-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-stretchr-testify-dev <!nocheck>,
               golang-github-urfave-cli-v2-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-term-dev,
               golang-golang-x-time-dev,
               golang-google-api-dev,
               golang-gopkg-yaml.v2-dev
Standards-Version: 4.7.0
Homepage: https://github.com/binwiederhier/ntfy
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-binwiederhier-ntfy
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-binwiederhier-ntfy.git
XS-Go-Import-Path: heckel.io/ntfy

Package: ntfy
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Send push notifications to your phone or desktop
 ntfy (pronounced "notify") is a simple HTTP-based pub-sub notification
 service. With ntfy, you can send notifications to your phone or desktop
 via scripts from any computer, without having to sign up or pay any
 fees. If you'd like to run your own instance of the service, you can
 easily do so since ntfy is open source.
 .
 This package provides the client and server for ntfy.
