=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
      https://github.com/binwiederhier/ntfy/tags .*/v?(\d\S*)\.tar\.gz debian

# opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
#     https://github.com/binwiederhier/ntfy/tags \
#     (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
